// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.ContributionItem;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.jface.action.IContributionManager;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.actions.ContributionItemFactory;
import org.eclipse.ui.internal.IPreferenceConstants;
import org.eclipse.ui.internal.Workbench;
import org.eclipse.ui.internal.WorkbenchPlugin;

import eu.etaxonomy.taxeditor.editor.internal.TaxeditorEditorPlugin;
import eu.etaxonomy.taxeditor.navigation.internal.TaxeditorNavigationPlugin;
import eu.etaxonomy.taxeditor.store.internal.TaxeditorStorePlugin;

/**
 * This is a wrapper for Eclipse's recently opened editors functionality. IsDirty()
 * and isDynamic() are both set to true to force redraw every time menu is opened.
 *
 * @author p.ciardelli
 * @created 23.04.2009
 * @version 1.0
 */
public class RecentNamesContributionItem extends ContributionItem {
	private static final Logger logger = Logger
			.getLogger(RecentNamesContributionItem.class);

	private IContributionItem recentWindows;
	private IContributionManager parent;

//	@SuppressWarnings("restriction")
//	RecentNamesContributionItem() {
////		WorkbenchPlugin.getDefault().getPreferenceStore().setValue(IPreferenceConstants.RECENT_FILES, 10);
//		TaxeditorNavigationPlugin.getDefault().getPreferenceStore().setValue("RECENT_FILES", 10);
//	}
	
	private IContributionItem getRecentWindows() {
		if (recentWindows == null) {
			
//	        int itemsToShow = TaxeditorNavigationPlugin.getDefault().getPreferenceStore()
//            		.getInt("RECENT_FILES");
				        
			recentWindows = ContributionItemFactory.REOPEN_EDITORS.create(NavigationUtil.getActiveWindow());
			recentWindows.setParent(parent);
		}
		return recentWindows;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IContributionItem#dispose()
	 */
	/** {@inheritDoc} */
	@Override
	public void dispose() {
		getRecentWindows().dispose();
		super.dispose();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IContributionItem#fill(org.eclipse.swt.widgets.Menu, int)
	 */
	/** {@inheritDoc} */
	@Override
	public void fill(Menu parent, int index) {
	//	getRecentWindows().fill(parent, index);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IContributionItem#isDirty()
	 */
	/** {@inheritDoc} */
	@Override
	public boolean isDirty() {
		return true;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IContributionItem#isDynamic()
	 */
	/** {@inheritDoc} */
	@Override
	public boolean isDynamic() {
		return true;
	}
}
