// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.navigation.navigator.handler;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.model.common.ITreeNode;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.editor.TaxonEditorInput;

/**
 * @author cmathew
 * @date 16 Jun 2015
 *
 */
public class NavigatorHandlerUtils {

    protected static boolean closeObsoleteEditor(ExecutionEvent event, TaxonNode taxonNode){
        IWorkbenchPage activePage = HandlerUtil.getActiveWorkbenchWindow(event).getActivePage();
        boolean result = true;
        for (IEditorReference ref : activePage.getEditorReferences()) {
            try {
                String treeIndex = ((ITreeNode)taxonNode).treeIndex();


                IEditorInput input = ref.getEditorInput();
                if (input instanceof TaxonEditorInput) {
                    TaxonNode node = ((TaxonEditorInput) input).getTaxonNode();
                    //if node is a child of taxonNode then close the editor
                    if( ((ITreeNode) node).treeIndex().startsWith(treeIndex)){
                    //if (taxonNode.equals(node)) {
                        result &= activePage.closeEditor(ref.getEditor(false), true);

                    }
                }
            } catch (PartInitException e) {
                continue;
            }
        }
        return result;
    }

}
